<?php

// ========================== 文件说明 ==========================//
// 本文件说明：缓存相关函数
// --------------------------------------------------------------//
// 本程序作者：angel
// --------------------------------------------------------------//
// 本程序版本：SaBlog-X Ver 1.6
// --------------------------------------------------------------//
// 本程序主页：http://www.sablog.net
// ========================== 开发环境 ==========================//
// register_globals = Off
// --------------------------------------------------------------//
// magic_quotes_gpc = On
// --------------------------------------------------------------//
// safe_mode = On
// --------------------------------------------------------------//
// Windows server 2003 & Linux & FreeBSD
// --------------------------------------------------------------//
// Apache/1.3.33 & PHP/4.3.2 & MySQL/4.0.17
// --------------------------------------------------------------//
// Apache/1.3.34 & PHP/4.4.1 & MySQL/5.0.16
// --------------------------------------------------------------//
// Apache/2.0.55 & PHP/5.1.1 & MySQL/5.0.15
// --------------------------------------------------------------//
// Copyright (C) Security Angel Team All Rights Reserved.
// ==============================================================//

if(!defined('SABLOG_ROOT')) {
	exit('Access Denied');
}

// 更新设置选项

function settings_recache()	{

	global $DB, $db_prefix;

	$settings = $DB->query("SELECT title, value FROM {$db_prefix}settings");
	$contents = "\$options = array(\r\n";

	while ($setting = $DB->fetch_array($settings)) {
		if ($setting['title'] == 'permalink_rules') {
			$contents.="\t'".sax_addslashes($setting['title'])."' => '".sax_addslashes($setting['value'])."',\r\n";
		} else {
			$contents.="\t'".sax_addslashes($setting['title'])."' => '".sax_addslashes(htmlspecialchars($setting['value']))."',\r\n";

		}
	}
	$contents .= ');';
	writetocache('settings',$contents);

}

// 更新分类
function categories_recache() {
	global $DB, $db_prefix, $options;
	$categories = $DB->query("SELECT * FROM {$db_prefix}categories ORDER BY displayorder");
	$contents = "\$catecache = array(\r\n";
	while ($cate = $DB->fetch_array($categories)) {
		$contents.="\t'".$cate['cid']."' => array(\r\n\t\t'cid' => '".$cate['cid']."',\r\n\t\t'name' => '".sax_addslashes($cate['name'])."',\r\n\t\t'articles' => '".$cate['articles']."',\r\n\t\t'url' => '".getcatelink($cate['cid'], $cate['url'])."',\r\n\t),\r\n";
	}
	$contents .= ');';
	writetocache('categories',$contents);
}

// 更新热门标签
function hottags_recache() {
	global $DB, $db_prefix, $options;
	$setting = $DB->fetch_one_array("SELECT value FROM {$db_prefix}settings WHERE title='hottags_shownum'");
	$limit = $setting['value'] ? intval($setting['value']) : 0;
	$query = $DB->query("SELECT * FROM {$db_prefix}tags ORDER BY usenum DESC LIMIT ".$limit);
	$contents = "\$tagcache = array(\r\n";
	while ($tag = $DB->fetch_array($query)) {
		$contents.="\t'".$tag['tagid']."' => array(\r\n\t\t'tagid' => '".$tag['tagid']."',\r\n\t\t'tag' => '".char_cv($tag['tag'])."',\r\n\t\t'url' => '".gettaglink(urlencode(char_cv($tag['tag'])))."',\r\n\t\t'usenum' => '".$tag['usenum']."',\r\n\t),\r\n";
	}
	$contents .= ');';
	writetocache('hottags',$contents);
}

// 更新归档
function archives_recache() {
	global $DB, $db_prefix,$options;
	$query = $DB->query("SELECT dateline FROM {$db_prefix}articles WHERE visible = '1' ORDER BY dateline DESC");
	$contents = "\$archivecache = array(\r\n";
	$articledb = array();
	while ($article = $DB->fetch_array($query)) {
		$articledb[] = sadate('Y-m',$article['dateline']);
	}
	unset($article);
	$DB->free_result($query);

	$archivedb = array_count_values($articledb);
	unset($articledb);
	$archivedb = array_slice($archivedb, 0, intval($options['archives_num']));

	foreach($archivedb as $key => $val){
		$v = explode('-', $key);		
		$contents.="\t'".$v[0]."-".$v[1]."' => array(\r\n\t\t'num' => '".$val."',\r\n\t\t'url'=>'".getdatelink($v[0].$v[1])."'\r\n\t),\r\n";
	}
	$contents .= ');';
	writetocache('archives',$contents);
}


// 更新链接

function links_recache() {

	global $DB, $db_prefix;
	$links = $DB->query("SELECT linkid,name,url,note FROM {$db_prefix}links WHERE visible = '1' ORDER BY displayorder ASC, name ASC");
	$linkdb = array();

	while ($link = $DB->fetch_array($links)) {

		$linkdb[] = $link;

	}
	unset($link);
	$tatol = count($linkdb);

	$contents  = "\$link_count = $tatol;\r\n";
	$contents .= "\$linkcache = array(\r\n";
	foreach($linkdb as $link){
		$contents.="\t'".$link['linkid']."' => array(\r\n\t\t'name' => '".sax_addslashes($link['name'])."',\r\n\t\t'url' => '".sax_addslashes($link['url'])."',\r\n\t\t'note' => '".sax_addslashes($link['note'])."',\r\n\t),\r\n";
	}
	$contents .= ');';
	writetocache('links',$contents);

}



// 更新最新评论

function newcomments_recache() {

	global $DB, $db_prefix, $options;
	$query = $DB->query("SELECT * FROM {$db_prefix}settings WHERE title IN ('recentcomment_num','recentcomment_limit')");
	$set = array();
	while ($r = $DB->fetch_array($query)) {
		$set[$r['title']] = $r['value'];
	}
	unset($r);

	$article_comment_num = intval($options['article_comment_num']);
	

	$newcomments = $DB->query("SELECT c.commentid, c.articleid, c.author, c.dateline, c.content, a.alias FROM {$db_prefix}comments c LEFT JOIN {$db_prefix}articles a ON (a.articleid=c.articleid) WHERE a.readpassword = '' AND a.visible='1' AND c.visible='1' ORDER BY commentid DESC LIMIT ".intval($set['recentcomment_num']));
	$contents = "\$newcommentcache = array(\r\n";
	$i=0;

	while ($newcomment = $DB->fetch_array($newcomments)) {
		$newcomment['content'] = preg_replace("/\[quote=(.*?)\]\s*(.+?)\s*\[\/quote\]/is", "", $newcomment['content']);
		if (empty($newcomment['content'])) {
			$newcomment['content'] = '......';
		}
		
		//处理链接
		if ($article_comment_num) {
			$cpost = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}comments WHERE articleid='".$newcomment['articleid']."' AND visible='1' AND commentid<='".$newcomment['commentid']."'"), 0);
			if (($cpost / $article_comment_num) <= 1 ) {
				$page = 1;
			} else {
				$page = @ceil($cpost / $article_comment_num);
			}
		} else {
			$page = 1;
		}
		$cmnum = '#cm'.$newcomment['commentid'];
		$artilce_url = getpermalink($newcomment['articleid'], $newcomment['alias'], ($page > 1 ? $page : 0)).$cmnum;
		//处理链接完毕

		$contents.="\t'".$i."' => array(\r\n\t\t'artilce_url' => '".$artilce_url."',\r\n\t\t'author' => '".sax_addslashes($newcomment['author'])."',\r\n\t\t'dateline' => '".sadate('m-d', $newcomment['dateline'])."',\r\n\t\t'content' => '".trimmed_title(htmlspecialchars(sax_addslashes(str_replace(array("\r\n","\n","\r"),'',$newcomment['content']))), $set['recentcomment_limit'])."',\r\n\t),\r\n";
		unset($newcomment);
		$i++;

	}
	$contents .= ');';
	writetocache('newcomments',$contents);

}

// 更新统计
function statistics_recache() {
	global $DB, $db_prefix, $timestamp;
	$stat = $DB->fetch_one_array("SELECT * FROM {$db_prefix}statistics LIMIT 1");
	//设置存活变量
	$contents  = "\$stats_expire = '".($timestamp + 900)."';\r\n";
	$contents .= "\$stats = array(\r\n";
	$contents .= "\t'cate_count' => '".$stat['cate_count']."',\r\n\t'article_count' => '".$stat['article_count']."',\r\n\t'comment_count' => '".$stat['comment_count']."',\r\n\t'tag_count' => '".$stat['tag_count']."',\r\n\t'attachment_count' => '".$stat['attachment_count']."',\r\n\t'trackback_count' => '".$stat['trackback_count']."',\r\n\t'user_count' => '".$stat['user_count']."',\r\n\t'online_user' => '".$stat['online_user']."',\r\n\t'online_robot' => '".$stat['online_robot']."',\r\n";
	$contents .= ');';
	writetocache('statistics',$contents);
}

// 更新模板自定义变量
function stylevars_recache() {
	global $DB, $db_prefix;
	$stylevars = $DB->query("SELECT * FROM {$db_prefix}stylevars WHERE visible='1'");
	$contents = "\$stylevar = array(\r\n";
	while ($var = $DB->fetch_array($stylevars)) {
		$contents.="\t'".strtolower($var['title'])."' => '".sax_addslashes($var['value'])."',\r\n";
	}
	$contents .= ');';
	writetocache('stylevars',$contents);
}

function autosave_recache($title = '', $description = '', $content = '') {
	global $sax_uid;
	$title = sax_addslashes($title);
	$description = sax_addslashes($description);
	$content = sax_addslashes($content);
	$autosavedb = array();
	@include_once(SABLOG_ROOT.'cache/cache_autosave.php');
	$autosavedb[$sax_uid] = array(
		'title' => $title,
		'description' => $description,
		'content' => $content
	);
	$contents = "\$autosavedb = unserialize('".serialize($autosavedb)."');";
	writetocache('autosave',$contents);
}

// 写入缓存文件

function writetocache($cachename, $cachedata = '') {
	if(in_array($cachename, array('archives','categories','hottags','links','newcomments','settings','statistics','stylevars','autosave'))) {
		$cachedir = SABLOG_ROOT.'cache/';
		$cachefile = $cachedir.'cache_'.$cachename.'.php';
		if(!is_dir($cachedir)) {
			@mkdir($cachedir, 0777);
		}
		$cachedata = "<?php\r\n//Sablog-X cache file\r\n//Created on ".sadate('Y-m-d H:i:s')."\r\n\r\nif(!defined('SABLOG_ROOT')) exit('Access Denied');\r\n\r\n".$cachedata."\r\n\r\n?>";
		if (!writefile($cachefile, $cachedata)) {
			exit('Can not write to '.$cachename.' cache files, please check directory ./cache/ .');
		}
	}
}

// 重新统计各种数据
function rethestats($cachename = '') {
	global $DB, $db_prefix;
	if (!$cachename || $cachename == 'settings') {
		settings_recache();
	}
	if (!$cachename || $cachename == 'statistics') {
		// 更新首页显示的分类数
		$cate_count = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}categories"), 0);
		$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET cate_count='$cate_count'");	
		// 更新首页显示的文章数
		$article_count = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}articles WHERE visible = '1'"), 0);
		$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET article_count='$article_count'");
		// 更新首页显示的评论数
		$comment_count = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}comments c LEFT JOIN {$db_prefix}articles a ON (a.articleid=c.articleid) WHERE a.visible='1' AND c.visible='1'"), 0);
		$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET comment_count='$comment_count'");
		// 更新首页显示的附件数
		$attachment_count = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}attachments aa LEFT JOIN {$db_prefix}articles a ON (a.articleid=aa.articleid) WHERE a.visible='1'"), 0);
		$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET attachment_count='$attachment_count'");
		// 更新首页显示的Trackback数
		$trackback_count = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}trackbacks t LEFT JOIN {$db_prefix}articles a ON (a.articleid=t.articleid) WHERE a.visible='1' AND t.visible='1'"), 0);
		$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET trackback_count='$trackback_count'");
		// 更新首页显示的标签(Tags)数
		$tag_count = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}tags"), 0);
		$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET tag_count='$tag_count'");
		// 更新主人发表文章数
		$query = $DB->query("SELECT userid FROM {$db_prefix}users WHERE groupid='1' OR groupid='2'");
		while ($user = $DB->fetch_array($query)) {
			$tatol = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}articles WHERE visible = '1' AND uid='".$user['userid']."'"), 0);
			$DB->unbuffered_query("UPDATE {$db_prefix}users SET articles='$tatol' WHERE userid='".$user['userid']."'");
		}
		statistics_recache();
	}
	if (!$cachename || $cachename == 'newcomments') {
		newcomments_recache();
	}
	if (!$cachename || $cachename == 'categories') {
		// 更新所有分类的文章数
		$query = $DB->query("SELECT cid, name FROM {$db_prefix}categories");
		while ($cate = $DB->fetch_array($query)) {
			$tatol = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}articles WHERE visible = '1' AND cid='".$cate['cid']."'"), 0);
			$DB->unbuffered_query("UPDATE {$db_prefix}categories SET articles='$tatol' WHERE cid='".$cate['cid']."'");
		}
		categories_recache();
	}
	if (!$cachename || $cachename == 'archives') {
		// 重建文章数据
		$query = $DB->query("SELECT articleid, title FROM {$db_prefix}articles");
		while ($article = $DB->fetch_array($query)) {
			// 更新所有文章的评论数
			$tatol = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}comments WHERE articleid='".$article['articleid']."' AND visible='1'"), 0);
			$DB->unbuffered_query("UPDATE {$db_prefix}articles SET comments='$tatol' WHERE articleid='".$article['articleid']."'");
			// 更新所有文章的Trackback数
			$tatol = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}trackbacks WHERE articleid='".$article['articleid']."' AND visible='1'"), 0);
			$DB->unbuffered_query("UPDATE {$db_prefix}articles SET trackbacks='$tatol' WHERE articleid='".$article['articleid']."'");
		}
		archives_recache();
	}
	if (!$cachename || $cachename == 'hottags') {
		hottags_recache();
	}
	if (!$cachename || $cachename == 'links') {
		links_recache();
	}
	if (!$cachename || $cachename == 'stylevars') {
		stylevars_recache();
	}
}

?>